/* 
 * Copyright (C) 2013-2014 Pier Luigi Fiorini
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <stdint.h>
#include "wayland-util.h"

extern const struct wl_interface org_kde_plasma_window_interface;
extern const struct wl_interface wl_surface_interface;

static const struct wl_interface *types[] = {
	NULL,
	NULL,
	&org_kde_plasma_window_interface,
	NULL,
	&wl_surface_interface,
	NULL,
	NULL,
	NULL,
	NULL,
	&wl_surface_interface,
};

static const struct wl_message org_kde_plasma_window_management_requests[] = {
	{ "show_desktop", "u", types + 0 },
	{ "get_window", "nu", types + 2 },
};

static const struct wl_message org_kde_plasma_window_management_events[] = {
	{ "show_desktop_changed", "u", types + 0 },
	{ "window", "u", types + 0 },
};

WL_EXPORT const struct wl_interface org_kde_plasma_window_management_interface = {
	"org_kde_plasma_window_management", 2,
	2, org_kde_plasma_window_management_requests,
	2, org_kde_plasma_window_management_events,
};

static const struct wl_message org_kde_plasma_window_requests[] = {
	{ "set_state", "uu", types + 0 },
	{ "set_virtual_desktop", "u", types + 0 },
	{ "set_minimized_geometry", "ouuuu", types + 4 },
	{ "unset_minimized_geometry", "o", types + 9 },
	{ "close", "", types + 0 },
};

static const struct wl_message org_kde_plasma_window_events[] = {
	{ "title_changed", "s", types + 0 },
	{ "app_id_changed", "s", types + 0 },
	{ "state_changed", "u", types + 0 },
	{ "virtual_desktop_changed", "i", types + 0 },
	{ "themed_icon_name_changed", "s", types + 0 },
	{ "unmapped", "", types + 0 },
};

WL_EXPORT const struct wl_interface org_kde_plasma_window_interface = {
	"org_kde_plasma_window", 1,
	5, org_kde_plasma_window_requests,
	6, org_kde_plasma_window_events,
};

